=== added directory 'msf_outgoing'
=== added file 'msf_outgoing/__init__.py'
--- msf_outgoing/__init__.py	1970-01-01 00:00:00 +0000
+++ msf_outgoing/__init__.py	2011-06-30 14:54:26 +0000
@@ -0,0 +1,25 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO consulting
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+import msf_outgoing
+import wizard
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'msf_outgoing/__openerp__.py'
--- msf_outgoing/__openerp__.py	1970-01-01 00:00:00 +0000
+++ msf_outgoing/__openerp__.py	2011-06-30 14:54:26 +0000
@@ -0,0 +1,51 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO consulting
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+{
+    "name" : "MSF Outgoing Management",
+    "version" : "0.1",
+    "author" : "MSF pam",
+    "category" : "Generic Modules/Inventory Control",
+    "description": """
+        MSF module covering business needs for outgoing movement from
+        an MSF instance.
+
+        Three main phases are used to describe the process:
+            - PICKING
+            - PACKING
+            - SHIPMENT
+        """,
+    'website': 'http://www.unifield.org',
+    'init_xml': [],
+    "depends" : ["stock", "purchase", "sale", "product_asset"],
+    'update_xml': [
+        'security/ir.model.access.csv',
+        'msf_outgoing_view.xml',
+        'wizard/create_picking_view.xml',
+        'wizard/stock_partial_move_view.xml',
+        'wizard/split_memory_move_view.xml',
+    ],
+    'demo_xml': [
+    ],
+    'test': [
+    ],
+    'installable': True,
+}
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added directory 'msf_outgoing/data'
=== added directory 'msf_outgoing/demo'
=== added file 'msf_outgoing/msf_outgoing.py'
--- msf_outgoing/msf_outgoing.py	1970-01-01 00:00:00 +0000
+++ msf_outgoing/msf_outgoing.py	2011-06-30 14:54:26 +0000
@@ -0,0 +1,248 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO consulting
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import osv, fields
+from tools.translate import _
+import netsvc
+from datetime import datetime, timedelta
+from dateutil.relativedelta import relativedelta
+import decimal_precision as dp
+
+class stock_picking(osv.osv):
+    '''
+    override stock picking to add new attributes
+    - flow_type: the type of flow (full, quick)
+    - subtype: the subtype of picking object (picking, ppl, packing)
+    - previous_step_id: the id of picking object of the previous step, picking for ppl, ppl for packing
+    '''
+    _inherit = 'stock.picking'
+    _name = 'stock.picking'
+    _columns = {'flow_type': fields.selection([('full', 'Full'),('quick', 'Quick')], string='Flow Type'),
+                'subtype': fields.selection([('picking', 'Picking'),('ppl', 'PPL'),('packing', 'Packing')], string='Subtype'),
+                }
+    
+    #@@@override stock
+    def action_assign(self, cr, uid, ids, *args):
+        '''
+        override to remove the error message, return False instead
+        '''
+        for pick in self.browse(cr, uid, ids):
+            move_ids = [x.id for x in pick.move_lines if x.state == 'confirmed']
+            if not move_ids:
+                return False
+            self.pool.get('stock.move').action_assign(cr, uid, move_ids)
+        return True
+    #@@@end
+    
+    def create_picking(self, cr, uid, ids, context=None):
+        '''
+        open the wizard to create (partial) picking tickets
+        '''
+        # we need the context for the wizard switch
+        if context is None:
+            context = {}
+        # create the memory object - passing the picking id to it through context
+        create_id = self.pool.get("create.picking").create(
+            cr, uid, {}, context=dict(context, active_ids=ids))
+        # call action to wizard view
+        return {
+            'name':_("Create Picking Ticket"),
+            'view_mode': 'form',
+            'view_id': False,
+            'view_type': 'form',
+            'res_model': 'create.picking',
+            'res_id': create_id,
+            'type': 'ir.actions.act_window',
+            'nodestroy': True,
+            'target': 'new',
+            'domain': '[]',
+            'context': dict(context, active_ids=ids, create_wizard_ids=[create_id])
+        }
+    
+stock_picking()
+
+
+class stock_move(osv.osv):
+    '''
+    
+    '''
+    _inherit = 'stock.move'
+    _name = 'stock.move'
+    
+    def _product_available(self, cr, uid, ids, field_names=None, arg=False, context=None):
+        '''
+        facade for product_available function from product (stock)
+        '''
+        # get the corresponding product ids
+        result = {}
+        for d in self.read(cr, uid, ids, ['product_id'], context):
+            result[d['id']] = d['product_id'][0]
+        
+        # get the virtual stock identified by product ids
+        virtual = self.pool.get('product.product')._product_available(cr, uid, result.values(), field_names, arg, context)
+        
+        # replace product ids by corresponding stock move id
+        result = dict([id, virtual[result[id]]] for id in result.keys())
+        return result
+    
+    _columns = {'virtual_available': fields.function(_product_available, method=True, type='float', string='Virtual Stock', help="Future stock for this product according to the selected locations or all internal if none have been selected. Computed as: Real Stock - Outgoing + Incoming.", multi='qty_available', digits_compute=dp.get_precision('Product UoM')),
+                }
+
+stock_move()
+
+
+class sale_order(osv.osv):
+    '''
+    re-override to modify behavior for outgoing workflow
+    '''
+    _inherit = 'sale.order'
+    _name = 'sale.order'
+
+    # @@@override@sale_override.sale.order.action_ship_create
+    def action_ship_create(self, cr, uid, ids, *args, **kwargs):
+        """
+        - no call to confirmation for picking object's workflow
+        - fill the new picking attributes (flow_type: 'full', subtype: 'picking')
+        - the picking state is 'draft'
+        - the move state is 'confirmed'
+        """
+        wf_service = netsvc.LocalService("workflow")
+        picking_id = False
+        move_obj = self.pool.get('stock.move')
+        proc_obj = self.pool.get('procurement.order')
+        company = self.pool.get('res.users').browse(cr, uid, uid).company_id
+        for order in self.browse(cr, uid, ids, context={}):
+            proc_ids = []
+            output_id = order.shop_id.warehouse_id.lot_output_id.id
+            picking_id = False
+            for line in order.order_line:
+                proc_id = False
+                date_planned = datetime.now() + relativedelta(days=line.delay or 0.0)
+                date_planned = (date_planned - timedelta(days=company.security_lead)).strftime('%Y-%m-%d %H:%M:%S')
+
+                if line.state == 'done':
+                    continue
+                move_id = False
+                if line.product_id and line.product_id.product_tmpl_id.type in ('product', 'consu') and not line.order_id.procurement_request:
+                    location_id = order.shop_id.warehouse_id.lot_stock_id.id
+                    if not picking_id:
+                        pick_name = self.pool.get('ir.sequence').get(cr, uid, 'stock.picking.out')
+                        picking_id = self.pool.get('stock.picking').create(cr, uid, {
+                            'name': pick_name,
+                            'origin': order.name,
+                            'type': 'out',
+                            # 'state': 'auto',
+                            'state': 'draft',
+                            'move_type': order.picking_policy,
+                            'sale_id': order.id,
+                            'address_id': order.partner_shipping_id.id,
+                            'note': order.note,
+                            'invoice_state': (order.order_policy=='picking' and '2binvoiced') or 'none',
+                            'company_id': order.company_id.id,
+                            # subtype
+                            'subtype': 'picking',
+                            # flow type
+                            'flow_type': 'full',
+                        })
+                    move_data =  {
+                        'name': line.name[:64],
+                        'picking_id': picking_id,
+                        'product_id': line.product_id.id,
+                        'date': date_planned,
+                        'date_expected': date_planned,
+                        'product_qty': line.product_uom_qty,
+                        'product_uom': line.product_uom.id,
+                        'product_uos_qty': line.product_uos_qty,
+                        'product_uos': (line.product_uos and line.product_uos.id)\
+                                or line.product_uom.id,
+                        'product_packaging': line.product_packaging.id,
+                        'address_id': line.address_allotment_id.id or order.partner_shipping_id.id,
+                        'location_id': location_id,
+                        'location_dest_id': output_id,
+                        'sale_line_id': line.id,
+                        'tracking_id': False,
+                        #'state': 'draft',
+                        'state': 'confirmed',
+                        #'state': 'waiting',
+                        'note': line.notes,
+                        'company_id': order.company_id.id,
+                    }
+                    move_data = self._hook_ship_create_stock_move(cr, uid, ids, move_data, line, *args, **kwargs)
+                    move_id = self.pool.get('stock.move').create(cr, uid, move_data)
+
+                if line.product_id:
+                    proc_data = {
+                        'name': line.name,
+                        'origin': order.name,
+                        'date_planned': date_planned,
+                        'product_id': line.product_id.id,
+                        'product_qty': line.product_uom_qty,
+                        'product_uom': line.product_uom.id,
+                        'product_uos_qty': (line.product_uos and line.product_uos_qty)\
+                                or line.product_uom_qty,
+                        'product_uos': (line.product_uos and line.product_uos.id)\
+                                or line.product_uom.id,
+                        'location_id': order.shop_id.warehouse_id.lot_stock_id.id,
+                        'procure_method': line.type,
+                        'move_id': move_id,
+                        'property_ids': [(6, 0, [x.id for x in line.property_ids])],
+                        'company_id': order.company_id.id,
+                    }
+                    proc_data = self._hook_ship_create_procurement_order(cr, uid, ids, proc_data, line, *args, **kwargs)
+                    proc_id = self.pool.get('procurement.order').create(cr, uid, proc_data)
+                    proc_ids.append(proc_id)
+                    self.pool.get('sale.order.line').write(cr, uid, [line.id], {'procurement_id': proc_id})
+                    if order.state == 'shipping_except':
+                        for pick in order.picking_ids:
+                            for move in pick.move_lines:
+                                if move.state == 'cancel':
+                                    mov_ids = move_obj.search(cr, uid, [('state', '=', 'cancel'),('sale_line_id', '=', line.id),('picking_id', '=', pick.id)])
+                                    if mov_ids:
+                                        for mov in move_obj.browse(cr, uid, mov_ids):
+                                            move_obj.write(cr, uid, [move_id], {'product_qty': mov.product_qty, 'product_uos_qty': mov.product_uos_qty})
+                                            proc_obj.write(cr, uid, [proc_id], {'product_qty': mov.product_qty, 'product_uos_qty': mov.product_uos_qty})
+
+            val = {}
+
+            if picking_id:
+                # the picking is kept in 'draft' state
+                #wf_service.trg_validate(uid, 'stock.picking', picking_id, 'button_confirm', cr)
+                self.pool.get('stock.picking').log_picking(cr, uid, [picking_id])
+
+            for proc_id in proc_ids:
+                wf_service.trg_validate(uid, 'procurement.order', proc_id, 'button_confirm', cr)
+                if order.state == 'proc_progress':
+                    wf_service.trg_validate(uid, 'procurement.order', proc_id, 'button_check', cr)
+
+            if order.state == 'shipping_except':
+                val['state'] = 'progress'
+                val['shipped'] = False
+
+                if (order.order_policy == 'manual'):
+                    for line in order.order_line:
+                        if (not line.invoiced) and (line.state not in ('cancel', 'draft')):
+                            val['state'] = 'manual'
+                            break
+            self.write(cr, uid, [order.id], val)
+        return True
+        # @@@end
+
+sale_order()

=== added file 'msf_outgoing/msf_outgoing_view.xml'
--- msf_outgoing/msf_outgoing_view.xml	1970-01-01 00:00:00 +0000
+++ msf_outgoing/msf_outgoing_view.xml	2011-06-30 14:54:26 +0000
@@ -0,0 +1,225 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<openerp>
+    <data>
+    
+    	<!-- delete outgoing delivery menuitem -->
+    	<delete model="ir.ui.menu" id="stock.menu_action_picking_tree"/>
+    	
+    	<!-- Changed name to 'Picking Tickets' -->
+		<record id="view_picking_ticket_tree" model="ir.ui.view">
+            <field name="name">picking.ticket.tree</field>
+            <field name="model">stock.picking</field>
+            <field name="type">tree</field>
+            <field name="arch" type="xml">
+                <tree colors="blue:state in ('draft');grey:state in ('cancel');red:state not in ('cancel', 'done') and date &lt; current_date" string="Picking Tickets">
+                    <field name="name"/>
+                    <field name="partner_id"/>
+                    <field name="origin"/>
+                    <field name="date"/>
+                    <field name="min_date"/>
+                    <field name="backorder_id" groups="base.group_extended"/>
+                    <field name="invoice_state"/>
+                    <field name="stock_journal_id" groups="base.group_extended" widget="selection"/>
+                    <field name="state"/>
+                    <button name="action_process" states="assigned" string="Process" type="object" icon="gtk-go-forward"/>
+                </tree>
+            </field>
+        </record>
+        
+        <!-- Remove 'Process Later' (draft_force_assign) and 'Process Now' (draft_validate) buttons -->
+        <!-- 'Check Availability' button available for 'draft' state -->
+        <!-- Add 'Create Picking...' button -->
+        <!-- Changed name to 'Picking Ticket' -->
+        <!-- Add 'Flow Type' drop down list -->
+        <!-- TREE -->
+        <!-- Remove 'Scrap Products' button -->
+        <!-- Remove 'Scrapped' -->
+        <!-- Remove 'Split in production lots' -->
+        <!-- Remove 'Put in current pack' -->
+        <!-- Remove 'Put in a new pack' -->
+        <!-- Remove 'Process' at stock.move level -->
+        <!-- FORM -->
+        <!-- Remove 'Scrap' button -->
+        <!-- Remove 'New Pack' -->
+        <!-- Remove 'tracking_id' -->
+        <!-- Remove 'Split' -->
+        <record id="view_picking_ticket_form" model="ir.ui.view">
+            <field name="name">picking.ticket.form</field>
+            <field name="model">stock.picking</field>
+            <field name="type">form</field>
+            <!-- without priority 'view_picking_form' from stock is used -->
+            <!-- but then other form view also use it... -->
+            <!-- <field eval="11" name="priority"/> -->
+            <field name="arch" type="xml">
+                <form string="Picking Ticket">
+                    <group col="6" colspan="4">
+                        <group colspan="4" col="4">
+                            <field name="name" readonly="1"/>
+                            <field name="origin" readonly="1"/>
+                            <field name="address_id" on_change="onchange_partner_in(address_id)" context="{'contact_display':'partner'}" colspan="4"/>
+                            <field name="invoice_state"/>
+                            <field name="backorder_id" readonly="1" groups="base.group_extended"/>
+                        </group>
+                        <group colspan="2" col="2">
+                            <field name="date"/>
+                            <field name="min_date" readonly="1"/>
+                            <field name="stock_journal_id" groups="base.group_extended" widget="selection"/>
+                        </group>
+                    </group>
+                    <notebook colspan="4">
+                        <page string="Products">
+                            <field colspan="4" name="move_lines" nolabel="1" widget="one2many_list" default_get="{'move_line':move_lines, 'address_out_id': address_id}">
+                                <tree colors="grey:scrapped==True" string="Stock Moves">
+                                    <field name="product_id"/>
+                                    <field name="product_qty" on_change="onchange_quantity(product_id, product_qty, product_uom, product_uos)"/>
+                                    <field name="product_uom" string="UoM"/>
+                                    <field name="product_uos" groups="product.group_uos"/>
+                                    <field name="prodlot_id" groups="base.group_extended"/>
+                                    <field name="tracking_id" groups="base.group_extended"/>
+                                    <field name="location_id"/>
+                                    <field name="virtual_available" />
+                                    <field name="date"/>
+                                    <field name="state"/>
+                                </tree>
+                                <form string="Stock Moves">
+                                    <group colspan="2" col="4">
+                                        <separator colspan="4" string="Move Information"/>
+                                        <field name="name" invisible="1" colspan="4" />
+                                        <field name="product_id" on_change="onchange_product_id(product_id,location_id,location_dest_id, parent.address_id)" colspan="4" />
+                                        <field name="product_qty" on_change="onchange_quantity(product_id, product_qty, product_uom, product_uos)" />
+                                        <field name="product_uom" string="Unit Of Measure" colspan="4" />
+                                        <field name="product_uos_qty" groups="product.group_uos" on_change="onchange_uos_quantity(product_id, product_uos_qty, product_uos, product_uom)" colspan="4" />
+                                        <field groups="product.group_uos" name="product_uos" on_change="onchange_quantity(product_id, product_qty, product_uom, product_uos)" colspan="4" />
+                                        <field groups="base.group_extended" name="product_packaging"  domain="[('product_id','=',product_id)]" colspan="4" />
+                                    </group>
+
+                                    <group colspan="2" col="2">
+                                        <separator string="Locations" colspan="2" />
+                                        <field name="location_id" domain="[('usage','=','internal')]" />
+                                        <field name="location_dest_id" domain="[('usage','&lt;&gt;','view')]" />
+                                    </group>
+
+                                    <group colspan="2" col="2">
+                                        <separator string="Dates" colspan="2" />
+                                        <field name="create_date" invisible="1"/>
+                                        <field name="date"/>
+                                        <field name="date_expected"/>
+                                    </group>
+
+                                    <group colspan="2" col="4" groups="base.group_extended">
+                                        <separator string="Traceability" colspan="4" groups="base.group_extended"/>
+                                        <field name="prodlot_id" groups="base.group_extended"
+                                            context="{'location_id':location_id, 'product_id':product_id}"
+                                            domain="[('product_id','=?',product_id)]"
+                                            on_change="onchange_lot_id(prodlot_id,product_qty, location_id, product_id, product_uom)" colspan="3"/>
+                                    </group>
+                                    <label string="" colspan="4"/>
+                                    <field name="state"/>
+                                    <group col="4" colspan="2">
+                                        <button name="action_cancel" states="assigned" string="Cancel Move" type="object" icon="gtk-cancel"/>
+                                        <button name="action_confirm" states="draft" string="Confirm" type="object" icon="gtk-apply"/>
+                                        <button name="force_assign" states="confirmed" string="Force Availability" type="object" icon="gtk-jump-to"/>
+                                        <button name="cancel_assign" states="assigned" string="Cancel Availability" type="object" icon="gtk-find"/>
+                                    </group>
+                                </form>
+                            </field>
+                            <group col="12" colspan="4">
+                                <field name="state" readonly="1"/>
+                                <field name="flow_type" />
+                                <button name="button_cancel" states="assigned,confirmed,draft" string="_Cancel Picking" icon="gtk-cancel"/>
+                                <button name="action_assign" states="draft,confirmed" string="Check Availability" type="object" groups="base.group_extended" icon="gtk-find"/>
+                                <button name="create_picking" states="draft" string="Create Picking..." type="object" groups="base.group_extended" icon="gtk-add" />
+                                <button name="force_assign" states="confirmed" string="Force Availability" type="object" icon="gtk-jump-to"/>
+                                <button name="action_process" states="assigned" string="Process" type="object" icon="gtk-go-forward"/>
+                                <button name="%(stock.act_stock_return_picking)d" string="Return Products" states="done" type="action" icon="gtk-execute"/>
+                                <button name="%(stock.action_stock_invoice_onshipping)d" string="Create Invoice" attrs="{'invisible': ['|','|',('state','&lt;&gt;','done'),('invoice_state','=','invoiced'),('invoice_state','=','none')]}"  type="action" icon="terp-gtk-go-back-rtl"/>
+                            </group>
+                        </page>
+                        <page string="Additional info" groups="base.group_extended,base.group_multi_company">
+                            <field name="auto_picking" groups="base.group_extended"/>
+                            <field name="date_done" groups="base.group_extended"/>
+                            <field name="move_type" groups="base.group_extended"/>
+                            <field name="type" groups="base.group_extended"/>
+                            <field name="company_id" groups="base.group_multi_company" widget="selection"/>
+                        </page>
+                        <page string="Notes">
+                            <field colspan="4" name="note" nolabel="1"/>
+                        </page>
+                    </notebook>
+                </form>
+            </field>
+        </record>
+
+		<!-- Changed name to 'Picking Tickets' -->
+        <record id="view_picking_ticket_search" model="ir.ui.view">
+            <field name="name">picking.ticket.search</field>
+            <field name="model">stock.picking</field>
+            <field name="type">search</field>
+            <field name="arch" type="xml">
+                <search string="Picking Tickets">
+                    <group col="8" colspan="4">
+                        <filter icon="terp-check" name="available" string="Available" domain="[('state','=','assigned')]" help="Assigned Delivery Orders"/>
+                        <filter icon="terp-camera_test" name="confirmed" string="Confirmed" domain="[('state','=','confirmed')]" help="Confirmed Delivery Orders"/>
+                        <filter icon="terp-dialog-close" name="done" string="Done" domain="[('state','=','done')]" help="Delivery orders already processed"/>
+                        <separator orientation="vertical"/>
+                        <filter icon="terp-accessories-archiver-minus" string="Back Orders" domain="[('backorder_id', '!=', False)]" help="Is a Back Order" groups="base.group_extended"/>
+                        <separator orientation="vertical"/>
+                        <filter icon="terp-dolar" name="to_invoice" string="To Invoice" domain="[('invoice_state','=','2binvoiced')]" help="Delivery orders to invoice"/>
+                        <separator orientation="vertical"/>
+                        <field name="name"/>
+                        <field name="partner_id" />
+                        <field name="origin"/>
+                        <field name="stock_journal_id" groups="base.group_extended" widget="selection"/>
+                        <field name="company_id" widget="selection" groups="base.group_multi_company"/>
+                   </group>
+                    <newline/>
+                    <group expand="0" string="Group By..." colspan="4" col="8">
+                        <filter string="Partner" icon="terp-partner" domain="[]" context="{'group_by':'partner_id'}"/>
+                        <separator orientation="vertical" />
+                        <filter string="State" icon="terp-stock_effects-object-colorize" domain="[]" context="{'group_by':'state'}"/>
+                        <separator orientation="vertical" />
+                        <filter string="Order Date" icon="terp-go-month" domain="[]"  context="{'group_by':'date'}"/>
+                        <filter string="Expected Date" icon="terp-go-month" domain="[]"  context="{'group_by':'min_date'}"/>
+                        <separator orientation="vertical" />
+                        <filter string="Journal" icon="terp-folder-orange" domain="[]" context="{'group_by':'stock_journal_id'}"  groups="base.group_extended"/>
+                    </group>
+                </search>
+            </field>
+        </record>
+
+		<!-- Added 'subtype' in domain -->
+        <record id="action_picking_ticket" model="ir.actions.act_window">
+            <field name="name">Picking Ticket</field>
+            <field name="res_model">stock.picking</field>
+            <field name="type">ir.actions.act_window</field>
+            <field name="view_type">form</field>
+            <field name="view_mode">tree,form,calendar</field>
+            <field name="domain">[('type','=','out'), ('subtype', '=', 'picking')]</field>
+            <field name="context">{'contact_display': 'partner_address'}</field>
+            <field name="search_view_id" ref="view_picking_ticket_search"/>
+            <field name="help">This is the list of all picking tickets (draft and confirmed) that have to be prepared from sales orders.</field>
+        </record>
+        <record id="action_picking_ticket_tree" model="ir.actions.act_window.view">
+            <field eval="1" name="sequence"/>
+            <field name="view_mode">tree</field>
+            <field name="view_id" ref="view_picking_ticket_tree"/>
+            <field name="act_window_id" ref="action_picking_ticket"/>
+        </record>
+        <record id="action_picking_ticket_form" model="ir.actions.act_window.view">
+            <field eval="2" name="sequence"/>
+            <field name="view_mode">form</field>
+            <field name="view_id" ref="view_picking_ticket_form"/>
+            <field name="act_window_id" ref="action_picking_ticket"/>
+        </record>
+        <record id="action_picking_ticket_cal" model="ir.actions.act_window.view">
+            <field eval="3" name="sequence"/>
+            <field name="view_mode">calendar</field>
+            <field name="act_window_id" ref="action_picking_ticket"/>
+        </record>
+        <menuitem action="action_picking_ticket" id="menu_action_picking_ticket" parent="stock.menu_stock_warehouse_mgmt" sequence="4"/>
+
+       	
+    
+    
+    </data>
+</openerp>
\ No newline at end of file

=== added directory 'msf_outgoing/security'
=== added file 'msf_outgoing/security/ir.model.access.csv'
--- msf_outgoing/security/ir.model.access.csv	1970-01-01 00:00:00 +0000
+++ msf_outgoing/security/ir.model.access.csv	2011-06-30 14:54:26 +0000
@@ -0,0 +1,1 @@
+"id","name","model_id:id","group_id:id","perm_read","perm_write","perm_create","perm_unlink"

=== added directory 'msf_outgoing/test'
=== added directory 'msf_outgoing/wizard'
=== added file 'msf_outgoing/wizard/__init__.py'
--- msf_outgoing/wizard/__init__.py	1970-01-01 00:00:00 +0000
+++ msf_outgoing/wizard/__init__.py	2011-06-30 14:54:26 +0000
@@ -0,0 +1,24 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+import create_picking
+import split_memory_move
+import stock_partial_move

=== added file 'msf_outgoing/wizard/create_picking.py'
--- msf_outgoing/wizard/create_picking.py	1970-01-01 00:00:00 +0000
+++ msf_outgoing/wizard/create_picking.py	2011-06-30 14:54:26 +0000
@@ -0,0 +1,224 @@
+
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import fields, osv
+from tools.translate import _
+import time
+
+class create_picking(osv.osv_memory):
+    _name = "create.picking"
+    _description = "Create Picking"
+    _columns = {
+        'date': fields.datetime('Date', required=True),
+        'product_moves_out' : fields.one2many('stock.move.memory.out', 'wizard_id', 'Moves'),
+        'product_moves_in' : fields.one2many('stock.move.memory.in', 'wizard_id', 'Moves'),
+     }
+    
+    def get_picking_type(self, cr, uid, picking, context=None):
+        picking_type = picking.type
+        for move in picking.move_lines:
+            if picking.type == 'in' and move.product_id.cost_method == 'average':
+                picking_type = 'in'
+                break
+            else:
+                picking_type = 'out'
+        return picking_type
+    
+    def default_get(self, cr, uid, fields, context=None):
+        """ To get default values for the object.
+         @param self: The object pointer.
+         @param cr: A database cursor
+         @param uid: ID of the user currently logged in
+         @param fields: List of fields for which we want default values
+         @param context: A standard dictionary
+         @return: A dictionary which of fields with values.
+        """
+        if context is None:
+            context = {}
+            
+        pick_obj = self.pool.get('stock.picking')
+        res = super(create_picking, self).default_get(cr, uid, fields, context=context)
+        picking_ids = context.get('active_ids', [])
+        if not picking_ids:
+            return res
+
+        result = []
+        for pick in pick_obj.browse(cr, uid, picking_ids, context=context):
+            pick_type = self.get_picking_type(cr, uid, pick, context=context)
+            for m in pick.move_lines:
+                if m.state in ('done', 'cancel'):
+                    continue
+                result.append(self.__create_partial_picking_memory(m, pick_type))
+
+        if 'product_moves_in' in fields:
+            res.update({'product_moves_in': result})
+        if 'product_moves_out' in fields:
+            res.update({'product_moves_out': result})
+        if 'date' in fields:
+            res.update({'date': time.strftime('%Y-%m-%d %H:%M:%S')})
+        return res
+    
+    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False, submenu=False):
+        result = super(create_picking, self).fields_view_get(cr, uid, view_id, view_type, context, toolbar, submenu)
+       
+        pick_obj = self.pool.get('stock.picking')
+        picking_ids = context.get('active_ids', False)
+
+        if not picking_ids:
+            # not called through an action (e.g. buildbot), return the default.
+            return result
+
+        for pick in pick_obj.browse(cr, uid, picking_ids, context=context):
+            picking_type = self.get_picking_type(cr, uid, pick, context=context)
+        
+        _moves_arch_lst = """<form string="%s">
+                        <field name="date" invisible="1"/>
+                        <separator colspan="4" string="%s"/>
+                        <field name="%s" colspan="4" nolabel="1" mode="tree,form" width="550" height="200" ></field>
+                        """ % (_('Process Document'), _('Products'), "product_moves_" + picking_type)
+        _moves_fields = result['fields']
+
+        # add field related to picking type only
+        _moves_fields.update({
+                            'product_moves_' + picking_type: {'relation': 'stock.move.memory.'+picking_type, 'type' : 'one2many', 'string' : 'Product Moves'}, 
+                            })
+
+        _moves_arch_lst += """
+                <separator string="" colspan="4" />
+                <label string="" colspan="2"/>
+                <group col="2" colspan="2">
+                <button icon='gtk-cancel' special="cancel"
+                    string="_Cancel" />
+                <button name="do_create_picking" string="Create Picking"
+                    colspan="1" type="object" icon="gtk-go-forward" />
+            </group>
+        </form>"""
+        result['arch'] = _moves_arch_lst
+        result['fields'] = _moves_fields
+        return result
+
+    def __create_partial_picking_memory(self, move, pick_type):
+        move_memory = {
+            'product_id' : move.product_id.id, 
+            'quantity' : move.product_qty, 
+            'product_uom' : move.product_uom.id, 
+            'prodlot_id' : move.prodlot_id.id, 
+            'move_id' : move.id,
+            'asset_id': move.asset_id.id,
+        }
+    
+        if pick_type == 'in':
+            move_memory.update({
+                'cost' : move.product_id.standard_price, 
+                'currency' : move.product_id.company_id.currency_id.id, 
+            })
+        return move_memory
+        
+    def do_create_picking(self, cr, uid, ids, context=None):
+        '''
+        create the picking ticket from selected stock moves
+        -> only related to 'out' type stock.picking
+        
+        - transform data from wizard
+        '''
+        # generate data
+        assert context, 'no context, method call is wrong'
+        assert 'active_ids' in context, 'No picking ids in context. Action call is wrong'
+        
+        pick_obj = self.pool.get('stock.picking')
+        picking_ids = context['active_ids']
+        partial = self.browse(cr, uid, ids[0], context=context)
+        partial_datas = {
+            'delivery_date' : partial.date
+        }
+        
+        for pick in pick_obj.browse(cr, uid, picking_ids, context=context):
+            moves_list = partial.product_moves_out
+
+            for move in moves_list:
+                partial_datas.setdefault('move%s' % (move.move_id.id), []).append({'product_id': move.product_id.id,
+                                                                                   'product_qty': move.quantity,
+                                                                                   'product_uom': move.product_uom.id,
+                                                                                   'prodlot_id': move.prodlot_id.id,
+                                                                                   'asset_id': move.asset_id.id,
+                                                                                   })
+        
+        # create the new picking object
+        # TODO origin is not copied if name is not supplied as default.
+        #      create a new sequence for each draft picking ticket, and bricoler with draft ref or something for traceability
+        new_pick_id = pick_obj.copy(cr, uid, picking_ids[0], {'move_lines': []}, context=context)
+        # create stock moves corresponding to partial datas
+        # for now, each new line from the wizard corresponds to a new stock.move
+        # it could be interesting to regroup according to production lot/asset id
+        for move in partial_datas:
+            
+        # display newly created picking ticket
+        return {
+            'name':_("Picking Ticket"),
+            'view_mode': 'form',
+            'view_id': False,
+            'view_type': 'form',
+            'res_model': 'stock.picking',
+            'res_id': new_pick_id,
+            'type': 'ir.actions.act_window',
+            'target': 'crush',
+        }
+
+    def do_partial(self, cr, uid, ids, context=None):
+        """ Makes partial moves and pickings done.
+        @param self: The object pointer.
+        @param cr: A database cursor
+        @param uid: ID of the user currently logged in
+        @param fields: List of fields for which we want default values
+        @param context: A standard dictionary
+        @return: A dictionary which of fields with values.
+        """
+        pick_obj = self.pool.get('stock.picking')
+        
+        picking_ids = context.get('active_ids', False)
+        partial = self.browse(cr, uid, ids[0], context=context)
+        partial_datas = {
+            'delivery_date' : partial.date
+        }
+
+        for pick in pick_obj.browse(cr, uid, picking_ids, context=context):
+            picking_type = self.get_picking_type(cr, uid, pick, context=context)
+            moves_list = picking_type == 'in' and partial.product_moves_in or partial.product_moves_out
+
+            for move in moves_list:
+                partial_datas['move%s' % (move.move_id.id)] = {
+                    'product_id': move.id, 
+                    'product_qty': move.quantity, 
+                    'product_uom': move.product_uom.id, 
+                    'prodlot_id': move.prodlot_id.id, 
+                }
+                if (picking_type == 'in') and (move.product_id.cost_method == 'average'):
+                    partial_datas['move%s' % (move.move_id.id)].update({
+                                                    'product_price' : move.cost, 
+                                                    'product_currency': move.currency.id, 
+                                                    })
+        pick_obj.do_partial(cr, uid, picking_ids, partial_datas, context=context)
+        return {'type': 'ir.actions.act_window_close'}
+
+create_picking()
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'msf_outgoing/wizard/create_picking_view.xml'
--- msf_outgoing/wizard/create_picking_view.xml	1970-01-01 00:00:00 +0000
+++ msf_outgoing/wizard/create_picking_view.xml	2011-06-30 14:54:26 +0000
@@ -0,0 +1,13 @@
+<?xml version="1.0" encoding="utf-8"?>
+<openerp>
+    <data>
+        <record id="action_create_picking" model="ir.actions.act_window">
+            <field name="name">Create Picking</field>
+            <field name="res_model">create.picking</field>
+            <field name="view_type">form</field>
+            <field name="view_mode">form</field>
+            <field name="target">new</field>
+        </record>
+
+    </data>
+</openerp>

=== added file 'msf_outgoing/wizard/split_memory_move.py'
--- msf_outgoing/wizard/split_memory_move.py	1970-01-01 00:00:00 +0000
+++ msf_outgoing/wizard/split_memory_move.py	2011-06-30 14:54:26 +0000
@@ -0,0 +1,123 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import fields, osv
+from tools.translate import _
+import decimal_precision as dp
+
+
+class split_memory_move(osv.osv_memory):
+    '''
+    wizard called to split a memory stock move from create picking wizard
+    '''
+    _name = "split.memory.move"
+    _description = "Split Memory Move"
+    _columns = {
+        'quantity': fields.float('Quantity',digits_compute=dp.get_precision('Product UOM')),
+    }
+    _defaults = {
+        'quantity': lambda *x: 0,
+    }
+    
+    def cancel(self, cr, uid, ids, context=None):
+        '''
+        return to picking creation wizard
+        '''
+        return {
+            'name':_("Create Picking Ticket"),
+            'view_mode': 'form',
+            'view_id': False,
+            'view_type': 'form',
+            'res_model': 'create.picking',
+            'res_id': context['create_wizard_ids'][0],
+            'type': 'ir.actions.act_window',
+            'nodestroy': True,
+            'target': 'new',
+            'domain': '[]',
+            'context': context
+        }
+
+    def split(self, cr, uid, ids, context=None):
+        # quick integrity check
+        assert context, 'No context defined, problem on method call'
+        assert ids == context['split_wizard_ids'], 'No split wizard id in context, problem on action creation'
+        # memory moves selected
+        memory_move_ids = context['memory_move_ids']
+        memory_move_obj = self.pool.get('stock.move.memory.out')
+        # quantity input
+        leave_qty = self.browse(cr, uid, ids[0], context=context).quantity
+        for memory_move in memory_move_obj.browse(cr, uid, memory_move_ids, context=context):
+            # integrity check on create picking wizard id
+            assert memory_move.wizard_id.id == context['create_wizard_ids'][0]
+            
+            # quantity from memory move
+            available_qty = memory_move.quantity
+            
+            # leave quantity must be greater than zero
+            if leave_qty <= 0:
+                raise osv.except_osv(_('Error!'),  _('Selected quantity to leave must be greater than 0.0.'))
+
+            # cannot select more than available
+            if leave_qty > available_qty:
+                raise osv.except_osv(_('Error!'),  _('Selected quantity to leave in the current stock move (%0.1f) exceeds the available quantity (%0.1f)'%(leave_qty, available_qty)))
+            
+            # cannot select all available
+            if leave_qty == available_qty:
+                raise osv.except_osv(_('Error !'),_('Selected quantity to leave in the current stock move is equal to available quantity (%i).'%(available_qty)))
+            
+            # quantity difference for new memory stock move
+            new_qty = available_qty - leave_qty
+            
+            # update the selected memory move
+            memory_move_obj.write(cr, uid, [memory_move.id], {
+                'quantity': leave_qty,
+            })
+            
+            # create new memory move
+            default_val = {'product_id': memory_move.product_id.id,
+                           'quantity': new_qty,
+                           'product_uom': memory_move.product_uom.id,
+                           'prodlot_id': memory_move.prodlot_id.id,
+                           'move_id': memory_move.move_id.id,
+                           'wizard_id': memory_move.wizard_id.id,
+                           'cost': memory_move.cost,
+                           'currency': memory_move.currency.id,
+                           'asset_id': memory_move.asset_id.id,
+            }
+            new_memory_move = memory_move_obj.create(cr, uid, default_val, context=context)
+                        
+        # go back to previous wizard (create picking)
+        return {
+            'name':_("Create Picking Ticket"),
+            'view_mode': 'form',
+            'view_id': False,
+            'view_type': 'form',
+            'res_model': 'create.picking',
+            'res_id': context['create_wizard_ids'][0],
+            'type': 'ir.actions.act_window',
+            'nodestroy': True,
+            'target': 'new',
+            'domain': '[]',
+            'context': context
+        }
+    
+split_memory_move()
+

=== added file 'msf_outgoing/wizard/split_memory_move_view.xml'
--- msf_outgoing/wizard/split_memory_move_view.xml	1970-01-01 00:00:00 +0000
+++ msf_outgoing/wizard/split_memory_move_view.xml	2011-06-30 14:54:26 +0000
@@ -0,0 +1,21 @@
+<?xml version="1.0" encoding="utf-8"?>
+<openerp>
+    <data>
+        <record id="view_split_memory_move_form_wizard" model="ir.ui.view">
+            <field name="name">Split move</field>
+            <field name="model">split.memory.move</field>
+            <field name="type">form</field>
+            <field name="arch" type="xml">
+            <form string="Split Memory Move">
+                <separator string="Quantity to leave in the selected move" colspan="4"/>
+                <field name="quantity"/>
+                <button name="cancel" string="_Cancel"
+                	type="object" icon='gtk-cancel' />
+                <button name="split" string="Ok"
+                    type="object" icon="gtk-ok" />
+            </form>
+            </field>
+        </record>
+
+    </data>
+</openerp>

=== added file 'msf_outgoing/wizard/stock_partial_move.py'
--- msf_outgoing/wizard/stock_partial_move.py	1970-01-01 00:00:00 +0000
+++ msf_outgoing/wizard/stock_partial_move.py	2011-06-30 14:54:26 +0000
@@ -0,0 +1,60 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 TeMPO Consulting, MSF
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import fields, osv
+from tools.translate import _
+import time
+
+
+class stock_partial_move_memory_out(osv.osv_memory):
+    '''
+    add the split method
+    '''
+    _inherit = "stock.move.memory.out"
+    
+    def split(self, cr, uid, ids, context=None):
+        '''
+        open the split wizard, the user can select the qty to leave in the stock move
+        '''
+        # we need the context for the wizard switch
+        if context is None:
+            context = {}
+        # create the memory object - passing the wizard id to it through context
+        split_id = self.pool.get("split.memory.move").create(
+            cr, uid, {}, context=dict(context, memory_move_ids=ids))
+        # call action to wizard view
+        return {
+            'name':_("Split Selected Stock Move"),
+            'view_mode': 'form',
+            'view_id': False,
+            'view_type': 'form',
+            'res_model': 'split.memory.move',
+            'res_id': split_id,
+            'type': 'ir.actions.act_window',
+            'nodestroy': True,
+            'target': 'new',
+            'domain': '[]',
+            'context': dict(context, memory_move_ids=ids, split_wizard_ids=[split_id])
+        }
+    
+    
+    
+stock_partial_move_memory_out()

=== added file 'msf_outgoing/wizard/stock_partial_move_view.xml'
--- msf_outgoing/wizard/stock_partial_move_view.xml	1970-01-01 00:00:00 +0000
+++ msf_outgoing/wizard/stock_partial_move_view.xml	2011-06-30 14:54:26 +0000
@@ -0,0 +1,30 @@
+<?xml version="1.0" encoding="utf-8"?>
+<openerp>
+    <data>
+
+        <record id="stock_move_memory_tree_out" model="ir.ui.view">
+            <field name="name">stock.move.memory.tree</field>
+            <field name="model">stock.move.memory.out</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="stock.stock_move_memory_tree_out" />
+			<field name="arch" type="xml">
+				<data>
+				
+					<field name="product_id" position="replace">
+						<field name="product_id" readonly="True" />
+					</field>
+					
+					<field name="product_uom" position="replace">
+						<field name="product_uom" readonly="True" />
+					</field>
+				
+					<field name="prodlot_id" position="after">
+						<button name="split" string="Split" colspan="1" type="object" icon="terp-stock_effects-object-colorize" />
+					</field>
+				
+				</data>
+			</field>
+		</record>
+        
+    </data>
+</openerp>

